# Class VulkanPhysicalDeviceProperties

java.lang.Object
com.io7m.jcoronado.api.VulkanPhysicalDeviceProperties

All Implemented Interfaces:
  `VulkanPhysicalDevicePropertiesType`

public final class VulkanPhysicalDeviceProperties extends Object implements VulkanPhysicalDevicePropertiesType
The basic properties of a device.

See Also:
  - "VkPhysicalDeviceProperties"

- ## Nested Class Summary

  Nested Classes
  Modifier and Type
  Class
  Description
  `static final class`
  `VulkanPhysicalDeviceProperties.Builder`
  Builds instances of type `VulkanPhysicalDeviceProperties`.

  ### Nested classes/interfaces inherited from interface VulkanPhysicalDevicePropertiesType

  `VulkanPhysicalDevicePropertiesType.Type`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `VulkanVersion`
  `apiVersion()`
  `static VulkanPhysicalDeviceProperties.Builder`
  `builder()`
  Creates a builder for `VulkanPhysicalDeviceProperties`.
  `static VulkanPhysicalDeviceProperties`
  `copyOf(VulkanPhysicalDevicePropertiesType instance)`
  Creates an immutable copy of a `VulkanPhysicalDevicePropertiesType` value.
  `VulkanVersion`
  `driverVersion()`
  `boolean`
  `equals(Object another)`
  This instance is equal to all instances of `VulkanPhysicalDeviceProperties` that have equal attribute values.
  `int`
  `hashCode()`
  Computes a hash code from attributes: `name`, `type`, `id`, `vendorId`, `apiVersion`, `driverVersion`.
  `int`
  `id()`
  `String`
  `name()`
  `String`
  `toString()`
  Prints the immutable value `VulkanPhysicalDeviceProperties` with attribute values.
  `VulkanPhysicalDevicePropertiesType.Type`
  `type()`
  `int`
  `vendorId()`
  `final VulkanPhysicalDeviceProperties`
  `withApiVersion(VulkanVersion value)`
  Copy the current immutable object by setting a value for the `apiVersion` attribute.
  `final VulkanPhysicalDeviceProperties`
  `withDriverVersion(VulkanVersion value)`
  Copy the current immutable object by setting a value for the `driverVersion` attribute.
  `final VulkanPhysicalDeviceProperties`
  `withId(int value)`
  Copy the current immutable object by setting a value for the `id` attribute.
  `final VulkanPhysicalDeviceProperties`
  `withName(String value)`
  Copy the current immutable object by setting a value for the `name` attribute.
  `final VulkanPhysicalDeviceProperties`
  `withType(VulkanPhysicalDevicePropertiesType.Type value)`
  Copy the current immutable object by setting a value for the `type` attribute.
  `final VulkanPhysicalDeviceProperties`
  `withVendorId(int value)`
  Copy the current immutable object by setting a value for the `vendorId` attribute.

  ### Methods inherited from class Object

  `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- ## Method Details

  - ### name

    public String name()
    Specified by:
      `name` in interface `VulkanPhysicalDevicePropertiesType`
    Returns:
      The device name

  - ### type

    public VulkanPhysicalDevicePropertiesType.Type type()
    Specified by:
      `type` in interface `VulkanPhysicalDevicePropertiesType`
    Returns:
      The device type

  - ### id

    public int id()
    Specified by:
      `id` in interface `VulkanPhysicalDevicePropertiesType`
    Returns:
      The device ID (unique for a specific vendor)

  - ### vendorId

    public int vendorId()
    Specified by:
      `vendorId` in interface `VulkanPhysicalDevicePropertiesType`
    Returns:
      The vendor ID

  - ### apiVersion

    public VulkanVersion apiVersion()
    Specified by:
      `apiVersion` in interface `VulkanPhysicalDevicePropertiesType`
    Returns:
      The highest version of Vulkan supported

  - ### driverVersion

    public VulkanVersion driverVersion()
    Specified by:
      `driverVersion` in interface `VulkanPhysicalDevicePropertiesType`
    Returns:
      The version of the underlying device driver

  - ### withName

    public final VulkanPhysicalDeviceProperties withName(String value)
    Copy the current immutable object by setting a value for the `name` attribute. An equals check used to prevent copying of the same value by returning `this`.
    Parameters:
      `value` - A new value for name
    Returns:
      A modified copy or the `this` object

  - ### withType

    public final VulkanPhysicalDeviceProperties withType(VulkanPhysicalDevicePropertiesType.Type value)
    Copy the current immutable object by setting a value for the `type` attribute. A value equality check is used to prevent copying of the same value by returning `this`.
    Parameters:
      `value` - A new value for type
    Returns:
      A modified copy or the `this` object

  - ### withId

    public final VulkanPhysicalDeviceProperties withId(int value)
    Copy the current immutable object by setting a value for the `id` attribute. A value equality check is used to prevent copying of the same value by returning `this`.
    Parameters:
      `value` - A new value for id
    Returns:
      A modified copy or the `this` object

  - ### withVendorId

    public final VulkanPhysicalDeviceProperties withVendorId(int value)
    Copy the current immutable object by setting a value for the `vendorId` attribute. A value equality check is used to prevent copying of the same value by returning `this`.
    Parameters:
      `value` - A new value for vendorId
    Returns:
      A modified copy or the `this` object

  - ### withApiVersion

    public final VulkanPhysicalDeviceProperties withApiVersion(VulkanVersion value)
    Copy the current immutable object by setting a value for the `apiVersion` attribute. A shallow reference equality check is used to prevent copying of the same value by returning `this`.
    Parameters:
      `value` - A new value for apiVersion
    Returns:
      A modified copy or the `this` object

  - ### withDriverVersion

    public final VulkanPhysicalDeviceProperties withDriverVersion(VulkanVersion value)
    Copy the current immutable object by setting a value for the `driverVersion` attribute. A shallow reference equality check is used to prevent copying of the same value by returning `this`.
    Parameters:
      `value` - A new value for driverVersion
    Returns:
      A modified copy or the `this` object

  - ### equals

    public boolean equals(Object another)
    This instance is equal to all instances of `VulkanPhysicalDeviceProperties` that have equal attribute values.
    Overrides:
      `equals` in class `Object`
    Returns:
      `true` if `this` is equal to `another` instance

  - ### hashCode

    public int hashCode()
    Computes a hash code from attributes: `name`, `type`, `id`, `vendorId`, `apiVersion`, `driverVersion`.
    Overrides:
      `hashCode` in class `Object`
    Returns:
      hashCode value

  - ### toString

    public String toString()
    Prints the immutable value `VulkanPhysicalDeviceProperties` with attribute values.
    Overrides:
      `toString` in class `Object`
    Returns:
      A string representation of the value

  - ### copyOf

    public static VulkanPhysicalDeviceProperties copyOf(VulkanPhysicalDevicePropertiesType instance)
    Creates an immutable copy of a `VulkanPhysicalDevicePropertiesType` value. Uses accessors to get values to initialize the new immutable instance. If an instance is already immutable, it is returned as is.
    Parameters:
      `instance` - The instance to copy
    Returns:
      A copied immutable VulkanPhysicalDeviceProperties instance

  - ### builder

    public static VulkanPhysicalDeviceProperties.Builder builder()
    Creates a builder for `VulkanPhysicalDeviceProperties`.

        VulkanPhysicalDeviceProperties.builder()
           .setName(String) // required name
           .setType(com.io7m.jcoronado.api.VulkanPhysicalDevicePropertiesType.Type) // required type
           .setId(int) // required id
           .setVendorId(int) // required vendorId
           .setApiVersion(com.io7m.jcoronado.api.VulkanVersion) // required apiVersion
           .setDriverVersion(com.io7m.jcoronado.api.VulkanVersion) // required driverVersion
           .build();

    Returns:
      A new VulkanPhysicalDeviceProperties builder